clubs/urls.py
from django.urls import path
from .import views

app_name = 'clubs'
urlpatterns = [
    path('', views.clubshome, name='clubshome'),
    path('history/', views.clubs_history, name='history'),
]

dpi_sms/urls.py
from django.contrib import admin
from django.urls import path, include
from mainapp.views import redirectView
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    #stands for homepage
    path('welcome/', include('mainapp.urls')),
    #regx will say for whom it's been made :p
    path('', redirectView),
    path('clubs/', include('clubs.urls')),
    path('teachers/', include('teachers.urls')),
]


urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

teachers/urls.py
from django.urls import path
from .import views


app_name = 'teachers'
urlpatterns = [
    path('', views.index, name='teachershome'),
    path('<int:teacher_id>/detail/', views.teacher_detail, name='teacher_detail'),
    path('add/', views.addTeacherView, name='add'),
    path('del/<int:pk>/', views.deleteView, name='delete'),
]

teachers/models.py
from django.db import models
from datetime import date


class Teacher(models.Model):
    name = models.CharField(max_length=30)
    techer_id = models.CharField(unique=True, max_length=6, null=True)
    designation = models.CharField(null=False, max_length=30)
    joined = models.DateField('Year-Month')
    phone = models.CharField(null=True, max_length=12)
       
    def __str__(self):
        return self.name


class TeacherInfo(models.Model):
    name = models.ForeignKey(Teacher, on_delete=models.CASCADE)
    image = models.ImageField(upload_to='media')
    gender = models.CharField(max_length=7)
    qualification = models.CharField(max_length=20)
    dateOfBirth = models.DateField()
    shortBio = models.CharField(max_length=85)
    email = models.EmailField(max_length=30)
    homeDistrict = models.CharField(max_length=20)
    currentLocation = models.CharField(max_length=80)
    description = models.TextField(max_length=400)

    def __str__(self):
        return str(self.name)


class EduLevel(models.Model):
    ''' This is to generate educational levels like
    ssc/hsc etc 
    '''
    teacher = models.ForeignKey(Teacher, on_delete=models.CASCADE)
    grade = models.CharField(max_length=15)
    yearCompleted = models.DateField()
    instituteName = models.CharField(max_length=100)

    def __str__(self):
        return self.grade


class TeacherQualification(models.Model):
    teacher = models.ForeignKey(Teacher, on_delete=models.CASCADE)
    level = models.ManyToManyField(EduLevel)

    def __str__(self):
        return str(self.teacher)

teachers/forms.py
from django import forms


class AddTeacherForm(forms.Form):
    name = forms.CharField(widget=forms.TextInput(attrs={
        'class': 'form-control',
        'placeholder': 'teacher name'
    }))
    teacher_pin = forms.CharField(widget=forms.TextInput(attrs={
        'class': 'form-control',
        'placeholder': 'enter unique id'
    }))
    designation = forms.CharField(widget=forms.TextInput(attrs={
        'class': 'form-control'
    }))
    joined = forms.DateField(widget=forms.TextInput(attrs={
        'class': 'form-control',
        'placeholder': 'yyyy-mm-dd'
    }))
    phone = forms.CharField(widget=forms.TextInput(attrs={
        'class': 'form-control'
    }))

teachers/views.py
from datetime import date
from django.shortcuts import render, redirect
from teachers.models import Teacher, TeacherInfo, TeacherQualification
from .forms import AddTeacherForm


# Index view
def index(request):
    teachers = Teacher.objects.order_by('techer_id')        # '-techer_id' for ascending order
    context = {
        'teachers': teachers,
    }
    return render(request, 'teachers/teacher_index.html', context)


# detail view
def teacher_detail(request, teacher_id):
    instructor = Teacher.objects.get(pk=teacher_id)
    details = TeacherInfo.objects.get(pk=teacher_id)

    def age(dob):
        today = date.today()
        return today.year - dob.year - ((today.month, today.day) < (dob.month, dob.day))

    instructorAge = age(details.dateOfBirth)
    qualifications = TeacherQualification.objects.all()
    context = {
        'instructor': instructor,
        'details': details,
        'instructorAge': instructorAge,
        'qualifications': qualifications,
    }
    return render(request, 'teachers/detail.html', context)


# create view
def addTeacherView(request):
    form = AddTeacherForm()
    if request.method == 'POST':
        form = AddTeacherForm(request.POST)
        if form.is_valid():
            name = form.cleaned_data['name']
            teacher_pin = form.cleaned_data['teacher_pin']
            designation = form.cleaned_data['designation']
            joined = form.cleaned_data['joined']
            phone = form.cleaned_data['phone']
            instance = Teacher(
                name=name, techer_id=teacher_pin,
                designation=designation, joined=joined,
                phone=phone
                )
            instance.save()
            form = AddTeacherForm()
            return redirect('/teachers/')

    else:
        form = AddTeacherForm()
    context = {
        'form': form,
    }
    return render(request, 'teachers/add_teacher.html', context)


# delete teacher
def deleteView(request, pk):
    obj = Teacher.objects.get(id=pk)
    obj.delete()
    return redirect('/teachers/')

templates/teachers/add_teacher.html
{% extends 'base.html' %}
{% load static %}
{% block body %}

<div class="col-md-12 p-4 border">
    <div class="row">
        <div class="col-md-8">
            <form action="" method="POST">
                {% csrf_token %}
                {{ form.as_p }}
                <input type="submit" value="Create" class="btn bg-custom1">
            </form>
        </div>
        <div class="col-md-3 ml-4 alert-warning p-4 rounded">
            <h3>Follow Guideline</h3>
            <p>
                Lorem ipsum dolor sit amet consectetur adipisicing elit. Accusamus eligendi laboriosam ea fugiat voluptates eos ipsum ipsa exercitationem eaque dicta.
            </p>
        </div>
    </div>
</div>

{% endblock %}

templates/teachers/detail.html
{% extends 'base.html' %}
{% load static %}
{% block body %}

<!-- Instructor SideCards -->
<div class="col-md-4">
    <!-- Pic and actions -->
    <div class="row">
        <div class="col-md-12 m-0 p-0 rounded" style="border-top: 3px solid #c7004c;">
            <div class="card">
                <div class="card-body text-center">
                    <img class="rounded-circle border" src="{{ details.image.url }}" height="130" width="130">
                    <h4>{{ instructor.name }}</h4>
                    <p class="text-muted">{{ instructor.designation|title }}</p>
                    <!-- Buttons -->
                    <div style="padding:0 21%;">
                    <a href="#" class="btn bg-custom1 float-left">Bio</a>
                        <div class="col-md-2 p-0 m-0 float-left ml-1" id="ButtonAction">
                            <div class="dropdown">
                                <button class="btn bg-custom1-dark text-light dropdown-toggle" type="button" data-toggle="dropdown"
                                    aria-haspopup="true" aria-expanded="false">
                                    Promotion
                                </button>
                                <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                                    <a class="dropdown-item" href="#">Level 1</a>
                                    <a class="dropdown-item" href="#">Level 2</a>
                                    <a class="dropdown-item" href="#">Level 3</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Instructor About Card -->
    <div class="row mt-2">
        <div class="col-md-12 m-0 p-0">
            <div class="card">
                <div class="card-header">
                    <h5>About Mr. {{ instructor.name }}</h5>
                </div>
                <div class="card-body">
                    {{ details.shortBio }}
                </div>
                <ul class="list-group list-group-flush">
                    <li class="list-group-item">
                        <span class="font-weight-bold float-left">Gender:</span>
                        <span class="float-right">{{ details.gender }}</span>
                    </li>
                    <li class="list-group-item">
                        <span class="font-weight-bold float-left">Age:</span>
                        <span class="float-right">{{ instructorAge }}</span>
                    </li>
                    <li class="list-group-item">
                        <span class="font-weight-bold float-left">Qualification:</span>
                        <span class="float-right">{{ details.qualification }}</span>
                    </li>
                    <li class="list-group-item">
                        <span class="font-weight-bold float-left">Joined in:</span>
                        <span class="float-right">{{ instructor.joined }}</span>
                    </li>
                </ul>
            </div>
        </div>
    </div>
    <!-- Instructor Field Expertise Card -->
    <div class="row mt-2 text-muted">
        <div class="col-md-12 m-0 p-0">
            <div class="card">
                <div class="card-header">
                    <h5>Field of expertise</h5>
                </div>
                <ul class="list-group list-group-flush">
                    <li class="list-group-item">
                        <span class="float-left font-weight-bold">HTML,CSS,Js</span>
                        <span class="float-right">
                            75%
                        </span>
                    </li>
                    <li class="list-group-item">
                        <span class="float-left font-weight-bold">Python</span>
                        <span class="float-right">
                            85%
                        </span>
                    </li>
                    <li class="list-group-item">
                        <span class="float-left font-weight-bold">Math</span>
                        <span class="float-right">
                            55%
                        </span>
                    </li>
                </ul>
            </div>
        </div>
    </div>
</div>
<!-- Instructor Main -->
<div class="col-md-8">
    <div class="card">
        <div class="card-header">
            <h4>{{ instructor.name }}: <span class="text-muted">{{ instructor.techer_id }}</span></h4>
        </div>
        <div class="card-body">
            <!-- teacher info table -->
            <table class="table table-borderless">
                <thead>
                    <tr>
                        <th scope="col">Moblile</th>
                        <th scope="col">Email</th>
                        <th scope="col">Address</th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>{{ instructor.phone }}</td>
                        <td>{{ details.email }}</td>
                        <td>{{  details.homeDistrict|capfirst }}</td>
                    </tr>
                </tbody>
            </table>
            <hr>
            <div class="describe">
                <p>
                    {{ details.description }}
                </p>
            </div>
            <hr>
            <div class="education">
                <h4>Education</h4>
                <ul>
                    {% for qualification in qualifications %}
                    <li>{{ qualification }}</li>
                    {% endfor %}
                </ul>
            </div>
            <div class="experience">
                <h4>Experience</h4>
                <ul>
                    <li>educational timeline</li>
                    <li>educational timeline</li>
                    <li>educational timeline</li>
                </ul>
            </div>
        </div>
    </div>
    <a href="{% url 'teachers:delete' instructor.id %}" class="btn btn-danger mt-2 float-right">Delete profile 
        <i class="far fa-trash-alt"></i>
    </a>
</div>

<div class="fixed-bottom p-4 float-right">
    <a href="{% url 'teachers:teachershome' %}" class="btn bg-custom1 float-right">
        <i class="fas fa-backward"></i>
        Back</a>
</div>

{% endblock %}

templates/teachers/teacher_index.html
{% extends 'base.html' %}
{% load static %}
{% block body %}

<div class="col-md-12">
    <div class="col-md-2 ml-0 pl-0 mb-2 float-left" id="ButtonAction">
        <div class="dropdown">
            <button class="btn bg-custom1 text-light dropdown-toggle" type="button" data-toggle="dropdown"
                aria-haspopup="true" aria-expanded="false">
                All teachers
            </button>
            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                <a class="dropdown-item" href="#">Order by joining date</a>
                <a class="dropdown-item" href="#">Order by ID</a>
                <a class="dropdown-item" href="#">Order by designation</a>
            </div>
        </div>
    </div> <!-- All teacher filter dropdown -->
    <a href="{% url 'teachers:add' %}" class="btn bg-custom1-dark float-left" style="margin-left: -25px;">
        Add new teacher
        <i class="fas fa-plus ml-1"></i>
    </a>
    <table class="table table-bordered table-hover"> 
        <thead>
          <tr>
            <th scope="col">ID</th>
            <th scope="col">Name</th>
            <th scope="col">Joined Date</th>
            <th scope="col">Contact</th>
          </tr>
        </thead>
        <tbody>
        {% for teacher in teachers %}
          <tr>
            <th scope="row"><a class="text-dark" href="{% url 'teachers:teacher_detail' teacher.id %}">
                {{ teacher.techer_id }}
            </a></th>
            <td><a href="{% url 'teachers:teacher_detail' teacher.id %}" class="text-dark">
                {{ teacher.name }}
            </a></td>
            <td><a href="{% url 'teachers:teacher_detail' teacher.id %}" class="text-dark">
                {{ teacher.joined }}
            </a></td>
            <td><a href="{% url 'teachers:teacher_detail' teacher.id %}" class="text-dark">
                {{ teacher.phone }}
            </a></td>
          </tr>
        {% endfor %}
        </tbody>
      </table> <!-- teachers list table -->
</div>

{% endblock %}